Attribute VB_Name = "basVideoRes"
'*******************************************************************
' VIDEORES.BAS - Displays the current video resolution.
'*******************************************************************
Option Explicit
#If Win32 Then
Private Declare Function GetDC& Lib "User32" (ByVal hWnd As Long)
Private Declare Function GetDeviceCaps% Lib "GDI32" (ByVal hDC&, _
                                               ByVal iCapability&)
#Else
Private Declare Function GetDC% Lib "User" (ByVal hWnd As Integer)
Private Declare Function GetDeviceCaps% Lib "GDI" (ByVal hDC%, _
                                               ByVal iCapability%)
#End If
'*******************************************************************
' Displays the video resolution in a message box.
'*******************************************************************
Sub Main()
    MsgBox GetResolution(True), vbInformation, "Video Resolution"
End Sub
'*******************************************************************
' Determines the width, and height of the screen in pixels, and the
' number of colors the screen can display at one time.
'*******************************************************************
Function GetResolution(bReturnColors As Boolean) As String
Dim iWidth, iHeight, iColors, ScreenHDC
Const BITSPIXEL = 12
Const PLANES = 14
    '***************************************************************
    ' Get the resolution using standard VB methods.
    '***************************************************************
    iWidth = Screen.Width \ Screen.TwipsPerPixelX
    iHeight = Screen.Height \ Screen.TwipsPerPixelY
    '***************************************************************
    ' Get the device context of the screen, and use GetDeviceCaps
    ' to find out how many colors the screen supports.
    '***************************************************************
    ScreenHDC = GetDC(0)
    iColors = GetDeviceCaps(ScreenHDC, PLANES) * 2 _
            ^ GetDeviceCaps(ScreenHDC, BITSPIXEL)
    '***************************************************************
    ' Only display the color resolution if the caller wants it.
    '***************************************************************
    If bReturnColors Then
        GetResolution = iWidth & "x" & iHeight & "x" & iColors
    Else
        GetResolution = iWidth & "x" & iHeight
    End If
End Function
